SystemOrganization addCategory: #'TAIS-BuscaMinas'!

SimpleSwitchMorph subclass: #Celda
	instanceVariableNames: 'esMina mouseAction minasCercanas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAIS-BuscaMinas'!

!Celda methodsFor: 'accessing' stamp: 'Jbvidal 6/7/2012 23:29'!
asignarValor
	|r|
	r := Random new.
	r := (r next * 10) rounded.
	(r = 1) ifTrue:[r:=-1]. 
	^r.
	
! !

!Celda methodsFor: 'accessing' stamp: 'Jbvidal 6/7/2012 21:48'!
esMina
	"comment stating purpose of message"
	^esMina 
	! !

!Celda methodsFor: 'accessing' stamp: 'AndreaDuque 6/4/2012 15:05'!
esMina:anObject

	esMina := anObject.! !

!Celda methodsFor: 'initialization' stamp: 'AndreaDuque 6/4/2012 16:08'!
initialize 
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	esMina := self asignarValor.
	self useSquareCorners.
	self turnOff! !

!Celda methodsFor: 'as yet unclassified' stamp: 'Jbvidal 6/7/2012 12:07'!
minasCercanas 
	"comment stating purpose of message"
	^minasCercanas ! !

!Celda methodsFor: 'as yet unclassified' stamp: 'Jbvidal 6/7/2012 12:07'!
minasCercanas:anObject

	minasCercanas  := anObject.! !

!Celda methodsFor: 'as yet unclassified' stamp: 'jbvidal 6/7/2012 09:45'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!Celda methodsFor: 'event handling' stamp: 'jbvidal 6/7/2012 09:46'!
mouseUp: anEvent
	mouseAction value! !

!Celda methodsFor: 'as yet unclassified' stamp: 'Jbvidal 6/7/2012 22:53'!
valorMina
Transcript show: 'valor minas',esMina asString.
(esMina >= 0 )ifTrue: [^0].
	(esMina >= 0)ifFalse:[^1]! !

BorderedMorph subclass: #Tablero
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAIS-BuscaMinas'!

!Tablero methodsFor: 'accessing' stamp: 'initialize 5/25/2012 12:45'!
cells

	^ cells! !

!Tablero methodsFor: 'accessing' stamp: 'initialize 5/25/2012 12:45'!
cells: anObject

	cells := anObject! !

!Tablero methodsFor: 'accessing' stamp: 'initialize 5/25/2012 12:18'!
cellsPerSide

	^ 10! !

!Tablero methodsFor: 'logica de juego' stamp: 'Jbvidal 6/8/2012 00:32'!
destaparCeldaAt:i at: j
	 ((cells at:i at:j)esMina= -1)ifTrue: [self gameOver ].
	 ((cells at:i at:j)esMina= -1)ifFalse: [
	(j>1) ifTrue:[ self  showNumberAt:i at:j-1].
	(i>1and: [j>1]) ifTrue:[ self  showNumberAt:i-1 at:j-1].
	(i > 1) ifTrue: [ self  showNumberAt:i-1 at:j].	
	(j< self cellsPerSide and: [i<self cellsPerSide] ) ifTrue:[  self  showNumberAt:i+1 at:j+1].
	(i<self cellsPerSide and: [j> 1] ) ifTrue:[ self  showNumberAt:i+1 at:j-1].
	(j < self cellsPerSide ) ifTrue: [ self  showNumberAt:i at:j+1].
	(i > 1 and:[j < self cellsPerSide]) ifTrue: [ self  showNumberAt:i-1 at:j+1].
	(i < self cellsPerSide) ifTrue: [ self  showNumberAt:i+1 at:j]. 
	]
	! !

!Tablero methodsFor: 'logica de juego' stamp: 'Jbvidal 6/8/2012 00:30'!
gameOver 

UIManager default request: 'Juego terminado' initialAnswer:''.! !

!Tablero methodsFor: 'initialization' stamp: 'Jbvidal 6/7/2012 11:18'!
initialize 
	| sampleCell width height n |
	
	super initialize.
	n := self cellsPerSide.
	sampleCell := Celda new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n)@(height*n)) + (2 * self borderWidth)).
	self cells: (Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ]).
	self minasCercanas.
	
	! !

!Tablero methodsFor: 'logica de juego' stamp: 'Jbvidal 6/7/2012 22:51'!
minasCercanas
|suma|
1 to: self cellsPerSide do: [:i | 
	1 to: self cellsPerSide do:[: j|
		((cells at:i at:j)esMina = -1 )ifFalse:[ 
		suma:= 0.
		"Transcript show: 'fila',i asString,'valor celda',(cells at: i  at: j) esMina asString ."
		(j>1) ifTrue:[suma:= (suma +  (cells at:i at: j-1 )valorMina)].
		(i>1and: [j>1]) ifTrue:[ suma:= (suma +(cells at: i - 1 at: j-1 )valorMina)].
		(i > 1) ifTrue: [ suma:= (suma + (cells at: i - 1 at: j )valorMina) ].	
		(j< self cellsPerSide and: [i<self cellsPerSide] ) ifTrue:[ suma:= (suma + (cells at: i + 1 at: j+1 )valorMina)].
		(i<self cellsPerSide and: [j> 1] ) ifTrue:[ suma:= (suma + (cells at: i + 1 at: j-1)valorMina)].
		(j < self cellsPerSide ) ifTrue: [ suma:= (suma + (cells at: i  at: j+1 )valorMina)  ].
		(i > 1 and:[j < self cellsPerSide]) ifTrue: [ suma:= (suma +  (cells at: i - 1 at: j+1 )valorMina) ].
		(i < self cellsPerSide) ifTrue: [ suma:= (suma +  (cells at: i + 1 at: j )valorMina) ]. 
	       (cells at: i at: j ) minasCercanas: suma  asString.
		].
	  	 ((cells at:i at:j)esMina = -1)ifTrue:[
			 (cells at: i at: j ) minasCercanas: -1.
		].  
	]. 
].
! !

!Tablero methodsFor: 'logica de juego' stamp: 'jbvidal 6/7/2012 09:43'!
newCellAt:  i at: j
	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropiate screen position. Answer the new cell"

	| c origin |
	c := Celda new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width ) @ ((j - 1) * c height) + origin.
	c mouseAction: [self destaparCeldaAt: i at: j].
	^c! !

!Tablero methodsFor: 'logica de juego' stamp: 'Jbvidal 6/8/2012 00:48'!
showNumberAt:i at: j

	  ((cells at:i at:j)esMina>0)ifTrue:[(cells at:i at: j)turnOff label:  (cells at: i  at: j )minasCercanas asString ].! !
